﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace AOUtils.Libraries
{
    public class OptimizedArgument
    {
        public OptimizedArgument(Argument arg, List<OptimizedRequirement> reqs)
        {
            Value = arg.Value;
            Requirements = reqs;
        }
        public OptimizedArgument()
        {
            Requirements = new List<OptimizedRequirement>();
        }
        [XmlAttribute("value")]
        public string Value
        {
            get;
            set;
        }
        [XmlElement("requirement", typeof(OptimizedRequirement))]
        public List<OptimizedRequirement> Requirements
        {
            get;
            set;
        }
    }
}
