﻿using System;

namespace AOUtils.Libraries
{
    [Flags]
    public enum AttackValueTypes : ulong
    {
        None = 0,
        Pistol = 1,
        RangedEnergy = 2,
        AssaultRifle = 4,
        Rifle = 8,
        Shotgun = 16,
        Dimach = 32,
        MartialArts = 64,
        Brawl = 128,
        TrapDisarm = 256,
        OneHandBlunt = 512,
        TwoHandBlunt = 1024,
        OneHandEdged = 2048,
        TwoHandEdged = 4096,
        MG_SMG = 8192,
        Piercing = 16384,
        MeleeEnergy = 32768,
        Bow = 65536,
        Grenade = 131072,
        NanoProgramming = 262144,
        HeavyWeapons = 524288,
        PsychologicalModification = 1048576,
        Strength = 2097152,
        ComputerLiteracy = 4194304,
        Psychology = 8388608,
        MechanicalEngineering = 16777216,
        SpaceTime = 33554432,
        Burst = 67108864,
        AimedShot = 134217728,
        BowSpecialAttack = 268435456,
        Parry = 536870912,
        SharpObject = 1073741824,
        Riposte = 2147483648,
        MaterialCreation = 4294967296,
        Chemistry = 8589934592,
        BiologicalMetamorphosis = 17179869184,
        MaterialMetamorphosis = 34359738368,
        MaxHealth = 68719476736,
        FullAuto = 137438953472,
        AMS = 274877906944,
        FirstAid = 549755813888,
        FastAttack = 1099511627776,
        Psychic = 2199023255552,
        CurrentNano = 4398046511104,
        Intelligence = 8796093022208,
        Tutoring = 17592186044416,
        QuantumFT = 35184372088832,
        SensoryImprovement = 70368744177664,
        Adventuring = 140737488355328,
        Agility = 281474976710656,
        Sense = 562949953421312,
        Stamina = 1125899906842624,
        Level = 2251799813685248,
        TimeExist = 4503599627370496,
        Ranged = AssaultRifle | Bow | Grenade | HeavyWeapons | MechanicalEngineering | MG_SMG | NanoProgramming | Pistol | RangedEnergy | Rifle | Shotgun,
        Melee = BiologicalMetamorphosis | FastAttack | Intelligence | MartialArts | MaterialCreation | MeleeEnergy | OneHandBlunt | OneHandEdged | Parry | Piercing | Psychology | Riposte | SpaceTime | TwoHandBlunt | TwoHandEdged | Tutoring,
        Other = ~(Ranged | Melee)
    }
}
